#!/usr/bin/env python
# coding: utf-8

# In[3]:


import math
import matplotlib.pyplot as plt
import numpy as np

# Create a figure and a 3D axes object
fig = plt.figure(figsize=(10, 10))    # Size the figure (inches)
ax = plt.axes(projection='3d')

# Generate some data for the graph
num_divisions = 1000
x = np.linspace(-2, 2, num_divisions)
y = np.linspace(-2, 2, num_divisions)
X, Y = np.meshgrid(x, y)

# 3𝑒−𝑟2𝑠𝑖𝑛(2𝜋𝑟)𝑐𝑜𝑠(3𝜃)
approach = 1
if approach == 1:
    Z = 3 * np.exp(-(X * X + Y * Y)) * \
        np.sin(2 * np.pi * np.sqrt(X * X + Y * Y)) * \
        np.cos(3 * np.arctan2(Y, X))
elif approach == 2:
    function = lambda x, y: \
        3 * math.exp(-(x * x + y * y)) * \
        math.sin(2 * math.pi * math.sqrt(x * x + y * y)) * \
        math.cos(3 * math.atan2(y, x))
    z = [[function(x_value, y_value) for x_value in x] for y_value in y]
    Z = np.array(z)

# Plot the surface
# For info on color maps, see https://matplotlib.org/stable/users/explain/colors/colormaps.html
# Add _r at the end of a color map name to reverse its colors.
# Note that color map names are case-sensitive (for some reason).
surf = ax.plot_surface(X, Y, Z, cmap='viridis')

# Add a colorbar to the plot
fig.colorbar(surf, shrink=0.5, aspect=5)

# Set labels for the axes
ax.set_xlabel('X')
ax.set_ylabel('Y')
ax.set_zlabel('Z')
ax.view_init(elev=15, azim=20)  # Set elevation and azimuth (degrees)

# Show the plot
plt.show()


# In[2]:


import numpy as np

x = [1, 2, 3]
y = ['a', 'b']
X, Y = np.meshgrid(x, y)
print(X)
print(Y)


# In[ ]:




